<?
  include_once(dirname(__FILE__) ."/include/main.php");

  $isAdmin = ($_GET["mode"] == "admin" && Helper::IsLoggedInAdmin());

  // no user specified and not admin mode - redirect to user list page
  if(!$isAdmin && !getUser() && !Session::GetPublicCreationCodeEntered()) Helper::Redirect("users.php");
  
  $errors = array();
  $user = getUser();
  $isNewUser = (!$user->ID);
  if($isNewUser) $user = new User();
  
  if($_POST["cancel"])
  {
    Helper::Redirect($isAdmin ? "users.php" : "index.php?". Helper::CreateQuerystring($user));
  }

  if($isAdmin && $_POST["deleteConfirmed"])
  {
    DataAccess::DeleteUserByID($user->ID);
    Helper::Redirect($isAdmin ? "users.php" : "index.php?". Helper::CreateQuerystring($user));
  }
  
  // any category handling button clicked?
  foreach($_POST as $key=>$value)
  {
    if(substr($key, 0, 15) == "deleteCategory_")
    {
      $deleteCategory = substr($key, 15);
      break;
    }
    if($key == "addCategory")
    {
      $addCategory = true;
      break;
    }
  }
  
  if($_POST["save"] || $_POST["delete"] || $deleteCategory || $addCategory)
  {
    // populate user object with data from form elements
    $user->Username = stripslashes($_POST["username"]);
    $password = stripslashes($_POST["password"]);
    if($password) $user->Password = md5($password);
    $user->FirstName = stripslashes($_POST["firstName"]);
    $user->LastName = stripslashes($_POST["lastName"]);
    $user->Email = stripslashes($_POST["email"]);
    if($isAdmin) $user->Visible = ($_POST["visible"] ? 1 : 0);
    if(!$isAdmin && $isNewUser) $user->Visible = 1;

    $defaultCategory = $_POST["defaultCategory"];
    $noOfCategoriesAdded = $_POST["noOfCategoriesAdded"];

    // the category array
    foreach($_POST as $key=>$value)
    {
      if(substr($key, 0, 17) == "categoryName_new_")
      {
        $id = "1_". sprintf("%08d", substr($key, 17));
        $categories[$id] = new Category();
        $categories[$id]->Name = stripslashes($value);
        $categories[$id]->UserID = $user->ID;
      }
      elseif(substr($key, 0, 13) == "categoryName_")
      {
        $id = "0_". sprintf("%08d", substr($key, 13));
        $categories[$id] = new Category();
        $categories[$id]->Name = stripslashes($value);
        $categories[$id]->UserID = $user->ID;
        $categories[$id]->ID = substr($key, 13);
      }
    }    
    ksort($categories);
    
    // shall we delete a category?
    if($deleteCategory)
    {
      if(count($categories) <= 1)
      {
        $errors[] = __("CAN_NOT_DELETE_ALL_CATEGORIES");
      }
      else
      {
        if(substr($deleteCategory, 0, 4) == "new_")
        {
          // unsaved categories can be deleted directly
          $id = "1_". sprintf("%08d", substr($deleteCategory, 4));
          unset($categories[$id]);
        }
        else
        {
          // for saved categories, we need to check for existing maps
          $id = "0_". sprintf("%08d", $deleteCategory);
          $noOfMapsInCategory = DataAccess::NoOfMapsInCategory($deleteCategory);
          if($noOfMapsInCategory > 0)
          {
            $errors[] = sprintf(__("CAN_NOT_DELETE_NONEMPTY_CATEGORY"), $categories[$id]->Name, $noOfMapsInCategory);
          }
          else
          {
            unset($categories[$id]);
          }
        } 
      }
    }
    
    if($addCategory)
    {
      $id = "1_". sprintf("%08d", $noOfCategoriesAdded);
      $categories[$id] = new Category();
      $categories[$id]->UserID = $user->ID;
      $noOfCategoriesAdded++;
    }
  }
  else
  {
    // first page visit
    if($isNewUser) 
    {
      $noOfCategoriesAdded = 0;
      if($isAdmin) $_POST["sendEmail"] = 1;
      $defaultCategoryNames = @split(";", __("DEFAULT_CATEGORY_NAMES"));
      sort($defaultCategoryNames);
      $categories = array();
      foreach($defaultCategoryNames as $dcn)
      {
        $c = new Category();
        $c->Name = $dcn;
        $categories["1_". sprintf("%08d", $noOfCategoriesAdded)] = $c;
        $noOfCategoriesAdded++;
      }
      $defaultCategory = "new_0";
    }
    else
    {
      $categories = $user->GetCategories();
      $defaultCategory = $user->DefaultCategoryID;  
    }

    $customizableSettings = Helper::GetCustomizableStrings();
    foreach($customizableSettings["settings"] as $key => $value)
    {
      $_POST["CV_$key"] = __($key);
    }
  }
  
  // create category data for output and make sure that there is a default category
  $categoryData = array();
  $defaultCategoryIndex = -1;
  foreach($categories as $key=>$c)
  {
    $d = array();
    $d["category"] = $c;
    if($c->ID)
    {
      $d["nameId"] = "categoryName_". $c->ID;
      $d["defaultValue"] = $c->ID;
      $d["deleteId"] = "deleteCategory_". $c->ID;
    }
    else
    {
      $id = (int)substr($key,2);
      $d["nameId"] = "categoryName_new_$id";
      $d["defaultValue"] = "new_$id";
      $d["deleteId"] = "deleteCategory_new_$id";
    }
    $d["defaultId"] = "categoryDefault_". $d["defaultValue"];
    if($defaultCategory == $d["defaultValue"]) $defaultCategoryIndex = count($categoryData);
    $categoryData[] = $d;
  }
  if($defaultCategoryIndex == -1) $defaultCategoryIndex = 0;
  $defaultCategory = $categoryData[$defaultCategoryIndex]["defaultValue"];
  
  if($_POST["save"])
  {
    // validate
    if(DataAccess::UsernameExists($user->Username, $user->ID))
    {
      $errors[] = __("USERNAME_EXISTS");
    }
    if(trim($user->Username) == "")
    {
      $errors[] = __("NO_USERNAME_ENTERED");
    }
    if(!$user->ID && trim($password) == "")
    {
      $errors[] = __("NO_PASSWORD_ENTERED");
    }
    if(trim($user->FirstName) == "")
    {
      $errors[] = __("NO_FIRST_NAME_ENTERED");
    }
    if(trim($user->LastName) == "")
    {
      $errors[] = __("NO_LAST_NAME_ENTERED");
    }
    if($user->Email == "") 
    {
      $errors[] = __("NO_EMAIL_ENTERED");
    }
    if($user->Email != "" && !Helper::IsValidEmailAddress($user->Email)) 
    {
      $errors[] = __("INVALID_EMAIL");
    }
    foreach($categories as $c)
    {
      if(trim($c->Name) == "") $emptyCategoryNameFound = true;
    }
    if($emptyCategoryNameFound) $errors[] = __("CATEGORY_NAME_CANNOT_BE_EMPTY");
    
    if(count($errors) == 0)
    {
      $userSettings = array();
      foreach($_POST as $key => $value)
      {
        if(substr($key, 0, 3) == "CV_")
        {
          $key = substr($key, 3);
          $userSettings[$key] = stripslashes($value);
        }  
      }
      DataAccess::SaveUser($user, $categories, $defaultCategoryIndex, $userSettings);
      
      // send welcome email
      if($isNewUser && !($isAdmin && !$_POST["sendEmail"]))
      {
        $fromName = __("DOMA_ADMIN_EMAIL_NAME");
        $subject = __("NEW_USER_EMAIL_SUBJECT");
        $baseAddress = Helper::GetWebsiteUrl();
        $userAddress = Helper::GetWebsiteUrl() ."/?user=". $user->Username;
        $body = sprintf(__("NEW_USER_EMAIL_BODY"), $user->FirstName, $baseAddress, $userAddress, $user->Username, $password);  
        $emailSent = true;
        $emailSentSuccessfully = Helper::SendEmail($fromName, $user->Email, $subject, $body);
      }
      
      // clear language cache
      Session::SetLanguageStrings(null);
      
      if($isAdmin)
      {
        Helper::Redirect("users.php". ($emailSent && !$emailSentSuccessfully ? "?error=email" : ""));
      }
      else
      {
        Helper::Redirect("index.php?". Helper::CreateQuerystring($user));
      }
    }
  }

?>
<?php print '<?xml version="1.0" encoding="UTF-8"?>'; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<link rel="stylesheet" href="style.css" type="text/css" />
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />
<title><?=(_SITE_TITLE ." :: ". $title)?></title>
<link rel="icon" type="image/png" href="gfx/favicon.png" />
<script type="text/javascript" src="js/prototype/prototype_1.6.0.3.js"></script>
<script type="text/javascript">
function showTooltip(control, visible)
{
  var tooltip = $(control.id + '_tooltip');
  if(!visible && !tooltip.hasClassName('hidden')) tooltip.addClassName('hidden');
  if(visible && tooltip.hasClassName('hidden')) tooltip.removeClassName('hidden');
}
</script>
</head>

<body id="editUserBody">
<div id="wrapper">
<? 
  if($isAdmin || $isNewUser)
  {
    Helper::CreateUserListTopbar(); 
  }
  else
  {
    Helper::CreateTopbar(); 
  }

  if($isAdmin) 
  {
    $title = ($user->ID ? sprintf(__("EDIT_USER_X"), $user->FirstName ." ". $user->LastName) : __("ADD_USER"));
    $info = ($user->ID ? __("ADMIN_EDIT_USER_INFO") : __("ADMIN_ADD_USER_INFO")) ." ". sprintf(__("REQUIRED_FIELDS_INFO"), '<span class="required">*</span>');
  }
  else
  {
    $title = ($isNewUser ? __("ADD_USER_PROFILE_TITLE") : __("EDIT_USER_PROFILE_TITLE"));
    $info = __("EDIT_USER_PROFILE_INFO") ." ". sprintf(__("REQUIRED_FIELDS_INFO"), '<span class="required">*</span>');
  }
  $atoms = array();
  if($isAdmin) $atoms[] = "mode=admin";
  if($user->ID) $atoms[] = Helper::CreateQuerystring($user);
?>
<div id="content">
<form class="wide" method="post" action="<?=$_SERVER["PHP_SELF"]?><?=(count($atoms) > 0 ? "?". join("&amp;", $atoms) : "")?>">

<h1><?=$title?></h1>

<p><?=$info?></p>

<? if(count($errors) > 0) { ?>

<ul class="error">
<?
  foreach($errors as $e)
  {
    print "<li>$e</li>";
  }
?>
</ul>

<? } ?>

<h2><?=__("PERSONAL_DETAILS_TITLE")?></h2>

<p><?=($isAdmin ? __("ADMIN_PERSONAL_DETAILS_INFO") : __("PERSONAL_DETAILS_INFO"))?></p>

<div class="container">
<input type="hidden" name="id" value="<?=$user->ID?>" />
<label for="username"><?=__("USERNAME")?></label>
<input type="text" class="text" name="username" id="username" value="<?=hsc($user->Username)?>" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);" /> <span class="required">*</span>
<div class="tooltip hidden" id="username_tooltip"><?=($isAdmin ? __("ADMIN_USERNAME_DESCRIPTION") : __("USERNAME_DESCRIPTION"))?></div>
</div>

<div class="container">
<label for="password"><?=__("PASSWORD")?></label>
<input type="password" class="password" name="password" id="password" value="<?=hsc($password)?>" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);" /><? if($isNewUser) print ' <span class="required">*</span>'; ?>
<div class="tooltip hidden" id="password_tooltip"><?=($isAdmin ? ($user->ID ? __("ADMIN_PASSWORD_DESCRIPTION_EXISTING_USER") : __("ADMIN_PASSWORD_DESCRIPTION_NEW_USER")) : __("PASSWORD_DESCRIPTION"))?></div>
</div>

<div class="container">
<label for="firstName"><?=__("FIRST_NAME")?></label>
<input type="text" class="text" name="firstName" id="firstName" value="<?=hsc($user->FirstName)?>" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);" /> <span class="required">*</span>
<div class="tooltip hidden" id="firstName_tooltip"><?=($isAdmin ? __("ADMIN_FIRST_NAME_DESCRIPTION") : __("FIRST_NAME_DESCRIPTION"))?></div>
</div>

<div class="container">
<label for="lastName"><?=__("LAST_NAME")?></label>
<input type="text" class="text" name="lastName" id="lastName" value="<?=hsc($user->LastName)?>" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);" /> <span class="required">*</span>
<div class="tooltip hidden" id="lastName_tooltip"><?=($isAdmin ? __("ADMIN_LAST_NAME_DESCRIPTION") : __("LAST_NAME_DESCRIPTION"))?></div>
</div>

<div class="container">
<label for="email"><?=__("EMAIL")?></label>
<input type="text" class="text" name="email" id="email" value="<?=hsc($user->Email)?>" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);" /> <span class="required">*</span>
<div class="tooltip hidden" id="email_tooltip"><?=($isAdmin ? __("ADMIN_EMAIL_DESCRIPTION") : __("EMAIL_DESCRIPTION"))?></div>
</div>

<? if($isAdmin && $isNewUser) { ?>
<div class="container">
<label for="sendEmail"><?=__("SEND_CONFIRMATION_EMAIL")?></label>
<input type="checkbox" class="checkbox" name="sendEmail" id="sendEmail"<? if($_POST["sendEmail"]) print ' checked="checked"'; ?> /> <?=__("SEND_CONFIRMATION_EMAIL_DESCRIPTION")?>
</div>
<? } ?>

<? if($isAdmin) { ?>
<div class="container">
<label for="visible"><?=__("VISIBLE")?></label>
<input type="checkbox" class="checkbox" name="visible" id="visible"<? if($user->Visible) print ' checked="checked"'; ?> /> <?=__("ADMIN_VISIBLE_DESCRIPTION")?>
</div>

<? } ?>

<h2><?=__("MAP_CATEGORIES_TITLE")?></h2>

<p><?=($isAdmin ? __("ADMIN_MAP_CATEGORIES_INFO") : __("MAP_CATEGORIES_INFO"))?></p>

<div class="container">
<label for="categoryContainer"><?=__("MAP_CATEGORIES")?></label>

<div id="categoryContainer">
<?
  foreach($categoryData as $d)
  {
    ?>
      <div class="category">
        <input type="text" class="text" name="<?=$d["nameId"]?>" id="<?=$d["nameId"]?>" value="<?=hsc($d["category"]->Name)?>" />
        <input type="radio" class="radio" name="defaultCategory" value="<?=$d["defaultValue"]?>" id="<?=$d["defaultId"]?>"<? if($defaultCategory == $d["defaultValue"]) print ' checked="checked"'; ?> />
        <label for="<?=$d["defaultId"]?>"><?=__("DEFAULT_CATEGORY")?></label>        
        <input type="submit" class="submit" name="<?=$d["deleteId"]?>" id="<?=$d["deleteId"]?>" value="<?=__("DELETE_CATEGORY")?>" />
      </div>
    <?
  }
  
  ?>  <div class="clear">
    <input type="submit" class="submit" name="addCategory" id="addCategory" value="<?=__("ADD_CATEGORY")?>" />
  </div>  

</div>
</div>

<h2><?=__("TEXTS_AND_SETTINGS_TITLE")?></h2>

<p><?=($isAdmin ? __("ADMIN_TEXTS_AND_SETTINGS_INFO") : __("TEXTS_AND_SETTINGS_INFO"))?></p>

<?
  $customizableSettings = Helper::GetCustomizableStrings();
  foreach($customizableSettings["settings"] as $key => $value)
  {
    $customizedValue = stripslashes($_POST["CV_$key"]);
    $description = __($customizableSettings["descriptions"][$key]);
    ?>
      <div class="container">
      <label for="CV_<?=$key?>"><?=hsc($key)?></label>
      <? if(strlen($value) < 60) { ?>
      <input type="text" class="text" name="CV_<?=$key?>" id="CV_<?=$key?>" value="<?=$customizedValue?>" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);" />
      <? } else { ?>
      <textarea name="CV_<?=$key?>" id="CV_<?=$key?>" rows="3" cols="50" style="height: <?=(2+2*ceil(strlen($customizedValue) / 80))?>em;" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);"><?=hsc($customizedValue)?></textarea>
      <? } ?>
      <div class="tooltip hidden" id="CV_<?=$key?>_tooltip"><?=$description?></div>
      </div>
    <?
  }
?>

<div class="buttons">
<input type="submit" class="submit" name="save" id="save" value="<?=__("SAVE")?>" />
<? if($isAdmin && !$_POST["delete"] && !$isNewUser) { ?>
<input type="submit" class="submit" name="delete" id="delete" value="<?=__("DELETE")?>" />
<? } elseif($isAdmin && $_POST["delete"]) { ?>
<input type="submit" class="submit" name="deleteConfirmed" id="deleteConfirmed" value="<?=__("CONFIRM_DELETION")?>" />
<? } ?>
<input type="submit" class="submit" name="cancel" id="cancel" value="<?=__("CANCEL")?>" />
<input type="hidden" name="noOfCategoriesAdded" value="<?=$noOfCategoriesAdded?>" />
</div>

</form>
</div>
</div>
</body>
</html>